library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity moduleTest is
	port (sysclk: in  std_logic;
          led   : out std_logic_vector(7 downto 0)	;
			 MBT_in: in std_logic;
			 MBT_out: out std_logic;
			 REV_SEL_switch: in std_logic;
			 REV_SEL_out: out std_logic;
			 RESET_out: out std_logic);
end moduleTest;

architecture Behavioral of moduleTest is

	signal count: std_logic_vector(7 downto 0):= "10101010";
	signal l_count: integer range 0 to 50000000 := 0;
	signal b_count: integer range 0 to 100000000 := 0;
	signal MBT_control: std_logic:='1';
	signal RESET_control: std_logic:='0';		 
	signal attempting_MultiBoot: std_logic:= '0';

begin  
   	process (sysclk, count, l_count,b_count,MBT_in)
    	begin
    	
			if(sysclk'event and sysclk = '1') then
				l_count <= l_count + 1;
				if(l_count >= 50000000) then
					l_count <= 0;
					count <= not count;			
					if(MBT_in = '0'and attempting_MultiBoot = '0') then
						MBT_control <='0';
						attempting_MultiBoot <= '1';
					end if;
				end if;

				if (attempting_MultiBoot='1') then
					b_count <= b_count + 1;
					if(b_count=10000000) then
						MBT_control <='1';
					end if;
					if(b_count=75000000) then
						RESET_control <='1';
					end if;
					if(b_count>=100000000) then
						b_count <= 0;
						RESET_control <= '0';
						attempting_MultiBoot <='0';
						
					end if;
				end if;

			end if;

     end process;

    
     led(7 downto 0) <=  count(7 downto 0);
	  MBT_out <= MBT_control;
	  RESET_out <= RESET_control;
	  REV_SEL_out<= REV_SEL_switch;


end Behavioral;