library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
library UNISIM;
use UNISIM.VComponents.all;


entity pattern2 is
	port (	sysclk: in  std_logic;
            PROG: out std_logic;
			   CF: out std_logic;
			   REV_sel_OUT: out std_logic;
				REV_sel_IN : in std_logic;
		   	MBT : in std_logic;
				RESET: in std_logic;
				INIT: out std_logic;
				DIN: in std_logic);
			   --led   : out std_logic_vector(4 downto 0);
			--	stateLED : out std_logic_vector(2 downto 0));
end pattern2;

architecture Behavioral of pattern2 is

--	signal count: std_logic_vector(4 downto 0):= "01010";
	signal l_count: integer range 0 to 50000000 := 0;

	signal didNotWork: std_logic:='0';

	
	signal PROG_control: std_logic:='1';
	signal CF_control: std_logic:='1';
	signal INIT_control: std_logic:='0';
	--signal REV_sel_control: std_logic:='1';
--	signal stLED : std_logic_vector(2 downto 0):="111";
	type state_type is (ST0,ST1,ST2,ST3,ST4,ST5,ST6,ST_initialize);
	signal PS,NS : state_type;

begin  
   
   sync_proc: process(sysclk,RESET)
	begin
		if(rising_edge(sysclk)) then		-- check the next state and update present state
			if(RESET='1')then
				PS<= ST_initialize;		    -- go into first state	to reset all signals
			else
				PS <= NS;
			end if;	     
		 end if;
	end process sync_proc;	
		
	comb_proc:  process (sysclk, MBT,l_count)
   begin
    	
		if(sysclk'event and sysclk = '1') then
			case PS is 
			
				when ST_initialize=>
					CF_control <= '1';
					PROG_control <= '1';
					INIT_control <='0';
					l_count<= 0;
					didNotWork<='0';
					NS<=ST0;


				when ST0 =>	 					-- state 0: start counter, check for trigger
				--	l_count <= l_count + 1;
				--	if(l_count >= 50000000) then
				--		stLED <="000";
				--		CF_control <= '1';
				--		PROG_control <= '1';
				--		INIT_control <='0';
				--		l_count <= 0;
				--		count <= not count;
				--	end if;
					
					if(didNotWork='0') then
						if(MBT='0'and NS=ST0)	then
							NS<=ST1;
						else
							NS<=ST0;
						end if;
					else
						NS<=ST6;
					end if;				
					

				when ST1 =>	 					-- state 1: set CF=LOW and REV_SEL
					l_count <= l_count + 1;
					--stLED <="001";
					if(l_count >= 25000000) then		
						CF_control <= '0';	
						--REV_sel_control <= '1';
						l_count<=0;						
						NS<=ST2;
					else
						NS<=ST1;
					end if;
										
				when ST2=>						--state 2: set CF=HIGH and INIT=HIGH after 300ns or Rev_sel set up time	
					l_count <= l_count + 1;
					--stLED <="010";
					if(l_count >=15) then
						l_count <=0;	
						CF_control <= '1';
						INIT_control <= '1';
						NS<=ST3;
					else
						NS<=ST2;
					end if;

		
				
				when ST3 =>						--state 3: check data on DIN/DO, for 0s, if 1s then go to idle state
					l_count <= l_count + 1;
				--	stLED <="011";
					if(l_count>=5) then
						if(DIN/='1') then
							NS<=ST4;
							l_count<=0;
							INIT_control<='0';
							CF_control<='0';
						elsif(l_count >= 20) then
							NS<=ST6;
							l_count <=0;
							didNotWork <= '1';
							INIT_control <= '0';
							CF_control<='1';
						else				
							NS<=ST3;
						end if;
					else
						NS<=ST3;
					end if;
				
				when ST4 =>	  					--state 4: set CF=LOW and rev_sel, setup for reconfig
					l_count <= l_count + 1;
					--stLED <="100";
					if(l_count >= 5) then		
						CF_control <= '0';	
						--REV_sel_control <= '1';
						INIT_control <='0';
						l_count<=0;						
						NS<=ST5;
					else
						NS<=ST4;
					end if;
										
				when ST5=>						--state 5: set CF=HIGH and set PROG=LOW after 300ns or Rev_sel set up time	
					l_count <= l_count + 1;
					--stLED <="101";
					if(l_count >=15) then
						l_count <=0;	
						CF_control <= '1';
						PROG_control <= '0';
						NS<=ST6;
					else
						NS<=ST5;
					end if;						

				when ST6 =>
					--stLED<= "110";

				end case;


			end if;
     end process comb_proc;

    
	  PROG <= PROG_control;
	  CF <= CF_control;
	  --REV_sel <= REV_sel_control;
	  INIT<= INIT_control;
	  REV_sel_OUT <= REV_sel_IN;
	  --led(4 downto 0) <=  count(4 downto 0);
	  --stateLED(2 downto 0) <= stLED(2 downto 0);


end Behavioral;
